package com.liang.service;

import com.liang.entity.PrjBudget;
import com.liang.entity.StaBudget;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageRequest;

import java.util.List;

/**
 * 经费预算(StaBudget)表服务接口
 *
 * @author makejava
 * @since 2023-04-09 22:07:01
 */
public interface StaBudgetService {

    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    StaBudget queryById(Integer id);

    /**
     * 分页查询
     *
     * @param staBudget   筛选条件
     * @param pageRequest 分页对象
     * @return 查询结果
     */
    Page<StaBudget> queryByPage(StaBudget staBudget, PageRequest pageRequest);

    /**
     * 新增数据
     *
     * @param staBudget 实例对象
     * @return 实例对象
     */
    StaBudget insert(StaBudget staBudget);

    /**
     * 修改数据
     *
     * @param staBudget 实例对象
     * @return 实例对象
     */
    StaBudget update(StaBudget staBudget);

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     * @return 是否成功
     */
    boolean deleteById(Integer id);

    /**
     * 根据项目删除数据
     *
     * @param xm
     * @return
     */
    boolean deleteByXm(Integer xm);

    /**
     * 更新预算
     *
     * @param staBudgets
     * @return
     */
    int updateBatch(List<StaBudget> staBudgets);

    /**
     * 根据项目类型（项目模板）插入
     *
     * @param xmlx
     * @return
     */
    int insertBatchByXmlx(String xmlx, Integer xm);

    /**
     * 获取经费列表
     *
     * @return
     */
    List<StaBudget> getBudgetList(Integer xm);
}
